## xtrkcad 5.1.2a

=== debian/changelog ===
xtrkcad (1:5.1.2a-1) unstable; urgency=medium

  * New upstream release.
    - Remove upstream applied debian/patches/0100-messages_h.patch.
    - Refresh debian/patches/0900-spelling-errors.patch.
  * Rename NEWS.Debian to NEWS.
  * Declare compliance with Debian Policy 4.5.0 (No changes needed).
  * Switch to debhelper-compat:
    - debian/control: change to debhelper-compat (=13).
    - remove debian/compat.
  * debian/copyright:
    - Remove File-Excluded.
    - Add year 2020 to myself.
  * debian/watch:
    - Fix syntax.

 -- Jörg Frings-Fürst <debian@jff.email>  Wed, 27 May 2020 22:14:59 +0200
