## xtrkcad 5.2.0~hg8988e0

=== debian/changelog ===
xtrkcad (1:5.2.0~hg8988e0-1~mx17+1) mx; urgency=medium

  * New upstream snapshot, build for MX 17.
  * Revert to debhelper 10 compat.
  * Refresh 0900-spelling-errors.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 07 Apr 2018 15:42:14 -0700
