=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: xtrkcad
 Section: editors
 Priority: optional
-Maintainer: Daniel E. Markle <dmarkle@ashtech.net>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Daniel E. Markle <dmarkle@ashtech.net>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
  Jörg Frings-Fürst <debian@jff.email>
 Build-Depends:
  cmake,
- debhelper-compat (= 13),
+ debhelper (>= 10),
  libgtk2.0-dev
-Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.1.3
 Homepage: http://xtrkcad.org/
-Vcs-Git: git://jff.email/opt/git/xtrkcad.git
-Vcs-Browser: https://jff.email/cgit/xtrkcad.git/
+Vcs-Git: git://anonscm.debian.org/collab-maint/xtrkcad.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/xtrkcad.git
 
 Package: xtrkcad
 Architecture: any
