=== debian/changelog ===
xtrkcad (1:5.2.0Beta2.1-2) unstable; urgency=medium

  * debian/patches:
    + Add 0901-implicit-function-declaration.patch. Fix FTBFS after dpkg enabled
      -Werror=implicit-function-declaration by default. (Closes: #1066691).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 03 Apr 2024 10:41:33 +0200

xtrkcad (1:5.2.0Beta2.1-1) unstable; urgency=medium

  * New upstream release.
  * New debian/xtrkcad-common.lintian-overrides:
    - Add national-encoding (xtr are data files).
  * Remove file to use upstream ones:
    - debian/xtrkcad.desktop
    - xtrkcad.desktop
  * debian/control:
    - Add new Build-Depend libzip-dev
  * debian/rules: 
    - Add export DEB_LDFLAGS_MAINT_APPEND to fix the ld error
      "multiple definition" (Closes: #958005).
  * Refresh patches:
    - debian/patches/0900-spelling-errors.patch.

 -- Jörg Frings-Fürst <debian@jff.email>  Sat, 22 Aug 2020 14:17:45 +0200
